angular.module('beamng.apps')
.directive('simpleDigMachometer', ['$log', 'StreamsManager', 'UiUnits', function ($log, StreamsManager, UiUnits) {
  return {
    template:
      '<di style="width:100%; height:100%;" class="bngApp" layout="column">' +
        '<div style="display:flex; justify-content: center; align-items: baseline;">' +
        //this ^ has to be display flex instead of the layout attribute from angular since the latter has no baseline option
          '<span style="font-size:1.25em; line-height:45px; font-weight:bold;">' +
            '<span class="cs10E8CA05";>{{speed.val}}</span>' +
          '</span>' +
          '<span class="cs10E8CA05"; style="font-size:1.25em; font-weight:bold; margin-left:2px";>{{SpeedUnit}}</span>' +
        '</div>',
    replace: true,
    restrict: 'EA',
    link: function (scope, element, attrs) {
      'use strict';
      StreamsManager.add(['electrics']);

      scope.$on('$destroy', function () {
        $log.debug('<simple-Machometer> destroyed');
        StreamsManager.remove(['electrics']);
      }); 
      scope.speed = {
        val: 0,
        unit: ''
      };
	  scope.C = {
        val: 0,
        unit: ''
      };
	  scope.Red = {
        val: 255,
        unit: ''
      };
	  scope.Green = {
        val: 255,
        unit: ''
      };
	  scope.Blue = {
        val: 255,
        unit: ''
      };
		var rgbToHex = function (rgb) { 
			var hex = Number(rgb).toString(16);
			if (hex.length < 2) {
				hex = "0" + hex;
			}
			return hex;
		};
		var fullColorHex = function(r,g,b) {   
			var red = rgbToHex(r);
			var green = rgbToHex(g);
			var blue = rgbToHex(b);
			return red+green+blue;
		};		
      scope.$on('streamsUpdate', function (event, streams) {  
        scope.$evalAsync(function () {
		  var Mach1,FlooredMach;
		  if (UiUnits.speed(0).unit == 'mph'){Mach1 = 767.269;}else{Mach1 = 1234.8;}
		  var spans = document.getElementsByClassName('cs10E8CA05');
		  var Rvar = [255, 223, 171, 173, 255, 64, 147, 25, 250, 220, 255];
		  var Gvar = [255, 154, 171, 206, 165, 224, 112, 25, 128, 20, 215];
		  var Bvar = [255, 154, 209, 164, 0, 208, 219, 112, 114, 60, 0];
          var AirSpeed = streams.electrics.airspeed;
		  var MachSpeed = AirSpeed / Mach1;		
		  if(AirSpeed < 343.5533){
			  scope.speed = UiUnits.speed(AirSpeed);
			  scope.speed.val = Math.round(scope.speed.val);
			  if(Mach1 == 767.269){scope.SpeedUnit = "MPH";}else{scope.SpeedUnit = "KPH";}
			  for (var i = 0; i < spans.length; i++) {
                    var span = spans[i];
                    span.style.color = '#'+fullColorHex(255,255,255);
                } 
			  FlooredMach = 0;
			  scope.C.val = 0;
		  }else{
			  scope.speed = UiUnits.speed(MachSpeed);
			  scope.speed.val = scope.speed.val.toFixed(2);
			  scope.SpeedUnit = "Mach";	
			  FlooredMach = Math.floor(scope.speed.val);
		    }			
			if(scope.SpeedUnit == "Mach"){								
				for(var T = 0; T < 3; T++){ 
					for (var i = 0; i < spans.length; i++) {
						var span = spans[i];
						span.style.color = '#'+fullColorHex(scope.Red.val,scope.Green.val,scope.Blue.val);
					} 					
					if(scope.Red.val < Rvar[scope.C.val]){scope.Red.val++;}else{if(scope.Red.val > Rvar[scope.C.val]){scope.Red.val--;}}
					if(scope.Green.val < Gvar[scope.C.val]){scope.Green.val++;}else{if(scope.Green.val > Gvar[scope.C.val]){scope.Green.val--;}}
					if(scope.Blue.val < Bvar[scope.C.val]){scope.Blue.val++;}else{if(scope.Blue.val > Bvar[scope.C.val]){scope.Blue.val--;}}	
				}
			  if((scope.Red.val == Rvar[scope.C.val]) && (scope.Green.val == Gvar[scope.C.val]) && (scope.Blue.val == Bvar[scope.C.val])){
					var C = 0;
					if(FlooredMach < 11){C = FlooredMach;}else{C = 10;}
					if(scope.C.val < C){
						scope.C.val++;
					}else{
						scope.C.val = 0;
					}
			    }
			}			
        });
      });
    }
  };
}]);